/* Generated By:JavaCC: Do not edit this line. TaskCompositionParser.java */
package org.objectweb.fractal.task.core.composition.parser;

import java.util.ArrayList;
import java.util.List;

import org.objectweb.fractal.adl.xml.XMLNode;
import org.objectweb.fractal.adl.xml.XMLNodeFactory;
import org.objectweb.fractal.task.core.composition.ast.Binding;
import org.objectweb.fractal.task.core.composition.ast.DecorationHelper;
import org.objectweb.fractal.task.core.composition.ast.Constant;
import org.objectweb.fractal.task.core.composition.ast.Export;
import org.objectweb.fractal.task.core.composition.ast.FunctionCall;
import org.objectweb.fractal.task.core.composition.ast.Import;
import org.objectweb.fractal.task.core.composition.ast.ImportContainer;
import org.objectweb.fractal.task.core.composition.ast.Instruction;
import org.objectweb.fractal.task.core.composition.ast.Pattern;
import org.objectweb.fractal.task.core.composition.ast.RecordField;
import org.objectweb.fractal.task.core.composition.ast.Task;
import org.objectweb.fractal.task.core.composition.ast.TaskDefinition;
import org.objectweb.fractal.task.core.composition.ast.ValueContainer;
import org.objectweb.fractal.task.core.composition.ast.Variable;
import org.objectweb.fractal.task.core.composition.ast.Constant.ConstantTypeEnum;
import org.objectweb.fractal.task.core.internal.TaskInternalError;
import org.xml.sax.SAXException;


@SuppressWarnings("all")
public class TaskCompositionParser implements TaskCompositionParserConstants {
  static String lastjavadoc = null;
  private String filename;
  private XMLNodeFactory nodeFactory;
  private String dtd;
  public void init(XMLNodeFactory nodeFactory, String dtd, String filename) {
    this.nodeFactory = nodeFactory;
    this.dtd = dtd;
    this.filename = filename;
    try {
      nodeFactory.checkDTD(dtd) ;
    } catch (SAXException e) {
      throw new TaskInternalError("Error in dtd file '" + dtd + "'" , e);
    }
  }

  private XMLNode newNode(String name, Token t) {
    XMLNode node;
    try {
      node = nodeFactory.newXMLNode(dtd, name);
    } catch (SAXException e) {
      throw new TaskInternalError("Unable to create node", e);
    }
    if (t == null) node.astSetSource(filename);
    else node.astSetSource(filename + ":" + t.beginLine + ", " + t.beginColumn);
    return node;
  }

  final public TaskDefinition getTaskDefinition() throws ParseException {
  Token t;
  String[] debug = null;
  Task taskNode;
  TaskDefinition taskDefinitionNode = (TaskDefinition)newNode("taskDefinition", null);
  Import importNode;
  Instruction instruction;
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IMPORT:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      Import(taskDefinitionNode);
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DEBUG:
      debug = DebugAnnotation();
      break;
    default:
      jj_la1[1] = jj_gen;
      ;
    }
    t = jj_consume_token(IDENTIFIER);
    taskNode = (Task)newNode("task", t);
    taskNode.setName(t.image);
    taskDefinitionNode.setTask(taskNode);
    if (debug != null) {
      DecorationHelper.setDebugDecoration(taskNode, debug);
    }
    Parameters(taskNode);
    jj_consume_token(LBRACE);
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXPORT:
      case BIND:
      case DEBUG:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_2;
      }
      Instruction(taskNode);
    }
    jj_consume_token(RBRACE);
    jj_consume_token(0);
   {if (true) return taskDefinitionNode;}
    throw new Error("Missing return statement in function");
  }

  final public void Import(ImportContainer container) throws ParseException {
  Token t;
  String className;
    jj_consume_token(IMPORT);
    t = jj_consume_token(IDENTIFIER);
    jj_consume_token(FROM);
    className = FullyQualifierName();
    jj_consume_token(SEMICOLON);
    Import importNode = (Import)newNode("import", t);
    importNode.setFunctionName(t.image);
    importNode.setClassName(className);
    container.addImport(importNode);
  }

  final public void Parameters(Task container) throws ParseException {
  Token t ;
  Variable parameterNode ;
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      t = jj_consume_token(IDENTIFIER);
        parameterNode = (Variable)newNode("variable", t);
        parameterNode.setName(t.image);
        container.addVariable(parameterNode);
      label_3:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[3] = jj_gen;
          break label_3;
        }
        jj_consume_token(COMMA);
        t = jj_consume_token(IDENTIFIER);
          parameterNode = (Variable)newNode("variable", t);
          parameterNode.setName(t.image);
          container.addVariable(parameterNode);
      }
      break;
    default:
      jj_la1[4] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
  }

  final public void Instruction(Task container) throws ParseException {
  String[] debug = null;
  Instruction instruction = (Instruction) newNode("instruction", null);
  container.addInstruction(instruction);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DEBUG:
      debug = DebugAnnotation();
        DecorationHelper.setDebugDecoration(instruction, debug);
      break;
    default:
      jj_la1[5] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EXPORT:
      Export(instruction);
      break;
    case BIND:
      Bind(instruction);
      break;
    default:
      jj_la1[6] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void Export(Instruction container) throws ParseException {
  Token t;
  Export exportNode;
  Pattern internalRecord;
    t = jj_consume_token(EXPORT);
    exportNode = (Export)newNode("export", t);
    container.setExport(exportNode);

    internalRecord = (Pattern) newNode("internalRecord", t);
    exportNode.setInternalRecord(internalRecord);
    Record(internalRecord);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case WHERE:
      jj_consume_token(WHERE);
      Value((ValueContainer)internalRecord);
      break;
    default:
      jj_la1[7] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AS:
      t = jj_consume_token(AS);
      Pattern externalRecord = (Pattern) newNode("externalRecord", t);
      exportNode.setExternalRecord(externalRecord) ;
      ExternalRecord(externalRecord);
      break;
    default:
      jj_la1[8] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
  }

  final public void Bind(Instruction container) throws ParseException {
  Token t;
  Binding bindingNode;
  Pattern clientRecord;
  Pattern serverRecord;
    t = jj_consume_token(BIND);
    bindingNode = (Binding)newNode("binding", t);
    container.setBinding(bindingNode);

    clientRecord = (Pattern) newNode("clientRecord", t);
    bindingNode.setClientRecord(clientRecord);
    Record(clientRecord);
    t = jj_consume_token(TO);
    serverRecord = (Pattern) newNode("serverRecord", t);
    bindingNode.setServerRecord(serverRecord);
    Record(serverRecord);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case WHERE:
      jj_consume_token(WHERE);
      Value((ValueContainer)bindingNode);
      break;
    default:
      jj_la1[9] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
  }

  final public void Record(Pattern patternNode) throws ParseException {
  Token  fieldName;
  String fieldValue;
  RecordField field;
  patternNode.setClosure(Pattern.CLOSED_PATTERN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CLIENT:
    case SERVER:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CLIENT:
        jj_consume_token(CLIENT);
                patternNode.setRole(Pattern.CLIENT_ROLE);
        break;
      case SERVER:
        jj_consume_token(SERVER);
                  patternNode.setRole(Pattern.SERVER_ROLE);
        break;
      default:
        jj_la1[10] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[11] = jj_gen;
      ;
    }
    jj_consume_token(LBRACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      fieldName = jj_consume_token(IDENTIFIER);
         field = (RecordField) newNode("recordField", fieldName);
         field.setName(fieldName.image);
         patternNode.addRecordField(field);
      jj_consume_token(COLON);
      Value(field);
      label_4:
      while (true) {
        if (jj_2_1(2)) {
          ;
        } else {
          break label_4;
        }
        jj_consume_token(COMMA);
        fieldName = jj_consume_token(IDENTIFIER);
           field = (RecordField) newNode("recordField", fieldName);
           field.setName(fieldName.image);
           patternNode.addRecordField(field);
        jj_consume_token(COLON);
        Value(field);
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        jj_consume_token(COMMA);
        jj_consume_token(DOTDOTDOT);
           patternNode.setClosure(Pattern.OPENED_PATTERN);
        break;
      default:
        jj_la1[12] = jj_gen;
        ;
      }
      break;
    case DOTDOTDOT:
      jj_consume_token(DOTDOTDOT);
                   patternNode.setClosure(Pattern.OPENED_PATTERN);
      break;
    default:
      jj_la1[13] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(RBRACE);
  }

  final public void ExternalRecord(Pattern externalRecord) throws ParseException {
  Token  fieldName;
  RecordField field ;
    jj_consume_token(LBRACE);
    fieldName = jj_consume_token(IDENTIFIER);
     field = (RecordField) newNode("recordField", fieldName);
     field.setName(fieldName.image);
     externalRecord.addRecordField(field);
    jj_consume_token(ASSIGN);
    Value(field);
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[14] = jj_gen;
        break label_5;
      }
      jj_consume_token(COMMA);
      fieldName = jj_consume_token(IDENTIFIER);
       field = (RecordField) newNode("recordField", fieldName);
       field.setName(fieldName.image);
         externalRecord.addRecordField(field);
      jj_consume_token(ASSIGN);
      Value(field);
    }
    jj_consume_token(RBRACE);
  }

// Predicate expressions
  final public void Value(ValueContainer container) throws ParseException {
  Constant constant;
  Variable variable;
  FunctionCall function;
    if (jj_2_2(2)) {
      function = Function();
        container.setFunction(function);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRUE:
      case FALSE:
      case NULL:
      case INTEGER_LITERAL:
      case STRING_LITERAL:
        constant = Constant();
        container.setConstant(constant) ;
        break;
      case IDENTIFIER:
        variable = Variable();
        container.setVariable(variable);
        break;
      default:
        jj_la1[15] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public FunctionCall Function() throws ParseException {
  Token t ;
  FunctionCall functionNode ;
    t = jj_consume_token(IDENTIFIER);
    functionNode = (FunctionCall) newNode("function", t) ;
    functionNode.setName(t.image) ;
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
    case FALSE:
    case NULL:
    case INTEGER_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
      FunctionParameters(functionNode);
      break;
    default:
      jj_la1[16] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
   {if (true) return functionNode ;}
    throw new Error("Missing return statement in function");
  }

  final public void FunctionParameters(FunctionCall functionNode) throws ParseException {
    FunctionParameter(functionNode);
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[17] = jj_gen;
        break label_6;
      }
      jj_consume_token(COMMA);
      FunctionParameter(functionNode);
    }
  }

  final public void FunctionParameter(FunctionCall container) throws ParseException {
  ValueContainer parameter = (ValueContainer) newNode("functionParameter", null);
  container.addFunctionParameter(parameter);
    Value(parameter);
  }

  final public Constant Constant() throws ParseException {
  Constant constantNode ;
  Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING_LITERAL:
      constantNode = StringConstant();
      break;
    case INTEGER_LITERAL:
      constantNode = IntegerConstant();
      break;
    case TRUE:
    case FALSE:
      constantNode = BooleanConstant();
      break;
    case NULL:
      constantNode = NullConstant();
      break;
    default:
      jj_la1[18] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
   {if (true) return constantNode;}
    throw new Error("Missing return statement in function");
  }

  final public Constant StringConstant() throws ParseException {
  Token t ;
    t = jj_consume_token(STRING_LITERAL);
    Constant constantNode = (Constant) newNode("constant", t);
    constantNode.setType(ConstantTypeEnum.STRING.toString()) ;
    constantNode.setValue(t.image.substring(1, t.image.length() - 1)) ;
    {if (true) return constantNode ;}
    throw new Error("Missing return statement in function");
  }

  final public Constant IntegerConstant() throws ParseException {
  Token t ;
    t = jj_consume_token(INTEGER_LITERAL);
    Constant constantNode = (Constant) newNode("constant", t) ;
    constantNode.setType(ConstantTypeEnum.INTEGER.toString()) ;
    constantNode.setValue(t.image) ;
    {if (true) return constantNode ;}
    throw new Error("Missing return statement in function");
  }

  final public Constant BooleanConstant() throws ParseException {
    Token t ;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
      t = jj_consume_token(TRUE);
      break;
    case FALSE:
      t = jj_consume_token(FALSE);
      break;
    default:
      jj_la1[19] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      Constant constantNode = (Constant)newNode("constant", t);
      constantNode.setType (ConstantTypeEnum.BOOLEAN.toString());
      constantNode.setValue(t.image);
      {if (true) return constantNode;}
    throw new Error("Missing return statement in function");
  }

  final public Constant NullConstant() throws ParseException {
    Token t ;
    t = jj_consume_token(NULL);
      Constant constantNode = (Constant)newNode("constant", t);
      constantNode.setType (ConstantTypeEnum.NULL.toString());
      constantNode.setValue(t.image);
      {if (true) return constantNode;}
    throw new Error("Missing return statement in function");
  }

  final public Variable Variable() throws ParseException {
  Token t ;
    t = jj_consume_token(IDENTIFIER);
    Variable variableNode = (Variable) newNode("variable", t);
    variableNode.setName(t.image) ;
    {if (true) return variableNode ;}
    throw new Error("Missing return statement in function");
  }

  final private String[] DebugAnnotation() throws ParseException {
  String s;
  List l;
  String[] result;
    jj_consume_token(DEBUG);
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING_LITERAL:
      s = StringLiteral();
                          result = new String[] {s};
      break;
    case LBRACE:
      jj_consume_token(LBRACE);
      l = new ArrayList();
      s = StringLiteral();
                          l.add(s);
      label_7:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[20] = jj_gen;
          break label_7;
        }
        jj_consume_token(COMMA);
        s = StringLiteral();
                                     l.add(s);
      }
      jj_consume_token(RBRACE);
      result = (String[]) l.toArray(new String[l.size()]);
      break;
    default:
      jj_la1[21] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(RPAREN);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final private String StringLiteral() throws ParseException {
  Token t ;
    t = jj_consume_token(STRING_LITERAL);
    {if (true) return t.image.substring(1, t.image.length() - 1);}
    throw new Error("Missing return statement in function");
  }

  final private String FullyQualifierName() throws ParseException {
  Token t ;
  StringBuffer name ;
    t = jj_consume_token(IDENTIFIER);
   name = new StringBuffer(t.image);
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOT:
        ;
        break;
      default:
        jj_la1[22] = jj_gen;
        break label_8;
      }
      jj_consume_token(DOT);
      t = jj_consume_token(IDENTIFIER);
     name.append('.').append(t.image);
    }
   {if (true) return name.toString();}
    throw new Error("Missing return statement in function");
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  final private boolean jj_3_2() {
    if (jj_3R_9()) return true;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_9() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  public TaskCompositionParserTokenManager token_source;
  JavaCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[23];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static private int[] jj_la1_2;
  static {
      jj_la1_0();
      jj_la1_1();
      jj_la1_2();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x40000,0x2000000,0x2006000,0x0,0x0,0x2000000,0x6000,0x20000,0x8000,0x20000,0x300000,0x300000,0x0,0x0,0x0,0x5c00000,0x5c00000,0x0,0x5c00000,0xc00000,0x0,0x0,0x0,};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {0x0,0x0,0x0,0x1000,0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1000,0x4004,0x1000,0x6,0x6,0x1000,0x2,0x0,0x1000,0x82,0x2000,};
   }
   private static void jj_la1_2() {
      jj_la1_2 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[2];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public TaskCompositionParser(java.io.InputStream stream) {
     this(stream, null);
  }
  public TaskCompositionParser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new JavaCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new TaskCompositionParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public TaskCompositionParser(java.io.Reader stream) {
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new TaskCompositionParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public TaskCompositionParser(TaskCompositionParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(TaskCompositionParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration e = jj_expentries.elements(); e.hasMoreElements();) {
        int[] oldentry = (int[])(e.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[84];
    for (int i = 0; i < 84; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 23; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 84; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 2; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
